require "gooi"

function love.load()
	gr = love.graphics
	kb = love.keyboard
	mo = love.mouse

	fontDir = "/fonts/"
	imgDir = "/imgs/"

	width = gr.getWidth()-- 200 * 3 in conf.lua
	height = gr.getHeight()-- 150 * 3 in conf.lua
	-- Please note, this^ will be overridden if you're in Android.

	scale = 3
	wCanvas, hCanvas = math.floor(width / scale), math.floor(height / scale)


	canvas = gr.newCanvas(wCanvas, hCanvas)
	canvas:setFilter("nearest", "nearest")
	gooi.setCanvas(canvas)

	style = {
		font = gr.newFont(fontDir.."04B_03__.TTF", 8),
		bgColor = {255, 0, 0, 170},
		roundInside = 0.4
	}
	gooi.setStyle(style)

	joy1 = gooi.newJoy()
	lbl1 = gooi.newLabel("0, 0"):fg("#ff00ff"):setOrientation("left")

	panel = gooi.newPanel(0, 0, wCanvas, hCanvas, "grid 7x3")
	:setColspan(2, 2, 2)-- Row 2, Column 2, span of 2
	:setColspan(4, 2, 2)
	:setRowspan(5, 1, 2)
	:setRowspan(5, 2, 2)
	:add(
		gooi.newLabel("Label"):setOrientation("center"),
		gooi.newButton("Button"):setIcon(imgDir.."mario.png"),
		gooi.newButton(""):setIcon(imgDir.."explosion.png"),
		gooi.newSlider(0.5):bg("#ffff0088"),
		gooi.newCheck("This is a checkbox"),
		gooi.newRadio({text = "Rad 1", radioGroup = "g1"}):select(),
		gooi.newRadio({text = "Rad 2", radioGroup = "g1"}):bg("#ff000088"),
		gooi.newText("Type here"),
		gooi.newBar(0):increaseAt(0.1):bg("#0000ff88"),
		gooi.newSpinner(0, 30, 15):bg("#00ff0088"),
		joy1,
		gooi.newKnob(0.5)
	)

	panel:add(lbl1, "7,1")
	panel:add(gooi.newRadio({text = "Scale x1", radioGroup = "g2"}):onRelease(function()
		scale, gooi.sx, gooi.sy = 1, 1, 1
		love.window.setMode(wCanvas * scale, hCanvas * scale)
	end), "5,3")
	panel:add(gooi.newRadio({text = "Scale x2", radioGroup = "g2"}):onRelease(function()
		scale, gooi.sx, gooi.sy = 2, 2, 2
		love.window.setMode(wCanvas * scale, hCanvas * scale)
	end), "6,3")
	panel:add(gooi.newRadio({text = "Scale x3", radioGroup = "g2"}):onRelease(function()
		scale, gooi.sx, gooi.sy = 3, 3, 3
		love.window.setMode(wCanvas * scale, hCanvas * scale)
	end):select(), "7,3")

	imgBg = gr.newImage(imgDir.."bg.png")
	imgBg:setFilter("nearest", "nearest")

	index = 0
end

function love.update(dt)
	gooi.update(dt)

	lbl1:setText(joy1:xValue()..", "..joy1:yValue())
end

function love.draw()
	-- Do canvas stuff:
	gr.setCanvas(canvas)
	gr.clear()

	gr.setColor(62, 131, 95)
	gr.rectangle("fill", 0, 0, width, height)

	gr.setColor(255, 255, 255)
	gr.draw(imgBg, 0, 0)

	gr.setCanvas()
	gr.draw(canvas, 0, 0, 0, scale, scale)--   <--Scale your canvas
	-- Then draw gooi in the same canvas:
	gooi.draw()--   <-- Same internal scale for gooi
end

-- Desktop:
function love.mousereleased(x, y, button) gooi.released() end
function love.mousepressed(x, y, button)  gooi.pressed() end
--[[
-- Android:
function love.touchpressed(id, x, y)  gooi.pressed(id, x, y) end
function love.touchreleased(id, x, y) gooi.released(id, x, y) end
function love.touchmoved(id, x, y) gooi.moved(id, x, y) end
]]


function love.textinput(text)
	gooi.textinput(text)
end
function love.keypressed(key)
	gooi.keypressed(key)
	if key == "escape" then
		quit()
	end
end

function quit()
	love.event.quit()
end

function r()
	return love.math.random(0, 255)
end
